
/* Python wrapper functions auto-generated by pidl */
#define PY_SSIZE_T_CLEAN 1 /* We use Py_ssize_t for PyArg_ParseTupleAndKeywords */
#include <Python.h>
#include "python/py3compat.h"
#include "includes.h"
#include <pytalloc.h>
#include "librpc/rpc/pyrpc.h"
#include "librpc/rpc/pyrpc_util.h"
#include "bin/default/librpc/gen_ndr/ndr_frsblobs.h"
#include "bin/default/librpc/gen_ndr/ndr_frsblobs_c.h"

/*
 * These functions are here to ensure they can be optimized out by
 * the compiler based on the constant input values
 */

static inline unsigned long long ndr_sizeof2uintmax(size_t var_size)
{
	switch (var_size) {
	case 8:
		return UINT64_MAX;
	case 4:
		return UINT32_MAX;
	case 2:
		return UINT16_MAX;
	case 1:
		return UINT8_MAX;
	}

	return 0;
}

static inline long long ndr_sizeof2intmax(size_t var_size)
{
	switch (var_size) {
	case 8:
		return INT64_MAX;
	case 4:
		return INT32_MAX;
	case 2:
		return INT16_MAX;
	case 1:
		return INT8_MAX;
	}

	return 0;
}

static inline PyObject *ndr_PyLong_FromLongLong(long long v)
{
	if (v > LONG_MAX || v < LONG_MIN) {
		return PyLong_FromLongLong(v);
	} else {
		return PyInt_FromLong(v);
	}
}

static inline PyObject *ndr_PyLong_FromUnsignedLongLong(unsigned long long v)
{
	if (v > LONG_MAX) {
		return PyLong_FromUnsignedLongLong(v);
	} else {
		return PyInt_FromLong(v);
	}
}

#include "librpc/gen_ndr/misc.h"
#include "librpc/gen_ndr/security.h"
#include "librpc/gen_ndr/frsrpc.h"
#include "librpc/gen_ndr/bkupblobs.h"
#include "librpc/gen_ndr/fscc.h"
static PyTypeObject frsblobs_InterfaceType;
static PyTypeObject decode_nt_backup_file_Type;
static PyTypeObject decode_frsrpc_StageHeader_Type;
static PyTypeObject decode_FileNetworkOpenInformation_Type;

static PyTypeObject *bkup_NTBackupFile_Type;
static PyTypeObject *BaseObject_Type;
static PyTypeObject *frsrpc_StageHeader_Type;
static PyTypeObject *fscc_FileNetworkOpenInformation_Type;
static PyTypeObject *ClientConnection_Type;
static PyTypeObject *ndr_syntax_id_Type;


static PyObject *py_decode_nt_backup_file_in_get_file(PyObject *obj, void *closure)
{
	struct decode_nt_backup_file *object = (struct decode_nt_backup_file *)pytalloc_get_ptr(obj);
	PyObject *py_file;
	py_file = pytalloc_reference_ex(bkup_NTBackupFile_Type, pytalloc_get_mem_ctx(obj), &object->in.file);
	return py_file;
}

static int py_decode_nt_backup_file_in_set_file(PyObject *py_obj, PyObject *value, void *closure)
{
	struct decode_nt_backup_file *object = (struct decode_nt_backup_file *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->in.file");
		return -1;
	}
	PY_CHECK_TYPE(bkup_NTBackupFile_Type, value, return -1;);
	if (talloc_reference(pytalloc_get_mem_ctx(py_obj), pytalloc_get_mem_ctx(value)) == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	object->in.file = *(struct bkup_NTBackupFile *)pytalloc_get_ptr(value);
	return 0;
}

static PyGetSetDef py_decode_nt_backup_file_getsetters[] = {
	{
		.name = discard_const_p(char, "in_file"),
		.get = py_decode_nt_backup_file_in_get_file,
		.set = py_decode_nt_backup_file_in_set_file,
		.doc = discard_const_p(char, "PIDL-generated element of base type bkup_NTBackupFile")
	},
	{ .name = NULL }
};

static PyObject *py_decode_nt_backup_file_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return pytalloc_new(struct decode_nt_backup_file, type);
}

static PyObject *py_decode_nt_backup_file_ndr_opnum(PyTypeObject *type)
{


	return PyInt_FromLong(0);
}

static PyObject *py_decode_nt_backup_file_ndr_pack(PyObject *py_obj, int ndr_inout_flags, uint32_t ndr_push_flags)
{
	const struct ndr_interface_call *call = NULL;
	struct decode_nt_backup_file *object = (struct decode_nt_backup_file *)pytalloc_get_ptr(py_obj);
	PyObject *ret = NULL;
	struct ndr_push *push = NULL;
	DATA_BLOB blob;
	enum ndr_err_code err;

	if (ndr_table_frsblobs.num_calls < 1) {
		PyErr_SetString(PyExc_TypeError, "Internal Error, ndr_interface_call missing for py_decode_nt_backup_file_ndr_pack");
		return NULL;
	}
	call = &ndr_table_frsblobs.calls[0];

	push = ndr_push_init_ctx(pytalloc_get_mem_ctx(py_obj));
	if (push == NULL) {
		PyErr_SetNdrError(NDR_ERR_ALLOC);
		return NULL;
	}

	push->flags |= ndr_push_flags;

	err = call->ndr_push(push, ndr_inout_flags, object);
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		TALLOC_FREE(push);
		PyErr_SetNdrError(err);
		return NULL;
	}
	blob = ndr_push_blob(push);
	ret = PyBytes_FromStringAndSize((char *)blob.data, blob.length);
	TALLOC_FREE(push);
	return ret;
}

static PyObject *py_decode_nt_backup_file_ndr_pack_in(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	const char * const kwnames[] = { "bigendian", "ndr64", NULL };
	PyObject *bigendian_obj = NULL;
	PyObject *ndr64_obj = NULL;
	uint32_t ndr_push_flags = 0;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, "|OO:__ndr_pack_in__",
		discard_const_p(char *, kwnames),
		&bigendian_obj,
		&ndr64_obj)) {
		return NULL;
	}

	if (bigendian_obj && PyObject_IsTrue(bigendian_obj)) {
		ndr_push_flags |= LIBNDR_FLAG_BIGENDIAN;
	}
	if (ndr64_obj && PyObject_IsTrue(ndr64_obj)) {
		ndr_push_flags |= LIBNDR_FLAG_NDR64;
	}

	return py_decode_nt_backup_file_ndr_pack(py_obj, NDR_IN, ndr_push_flags);
}

static PyObject *py_decode_nt_backup_file_ndr_pack_out(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	const char * const kwnames[] = { "bigendian", "ndr64", NULL };
	PyObject *bigendian_obj = NULL;
	PyObject *ndr64_obj = NULL;
	uint32_t ndr_push_flags = 0;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, "|OO:__ndr_pack_out__",
		discard_const_p(char *, kwnames),
		&bigendian_obj,
		&ndr64_obj)) {
		return NULL;
	}

	if (bigendian_obj && PyObject_IsTrue(bigendian_obj)) {
		ndr_push_flags |= LIBNDR_FLAG_BIGENDIAN;
	}
	if (ndr64_obj && PyObject_IsTrue(ndr64_obj)) {
		ndr_push_flags |= LIBNDR_FLAG_NDR64;
	}

	return py_decode_nt_backup_file_ndr_pack(py_obj, NDR_OUT, ndr_push_flags);
}

static PyObject *py_decode_nt_backup_file_ndr_unpack(PyObject *py_obj, const DATA_BLOB *blob, int ndr_inout_flags, uint32_t ndr_pull_flags, bool allow_remaining)
{
	const struct ndr_interface_call *call = NULL;
	struct decode_nt_backup_file *object = (struct decode_nt_backup_file *)pytalloc_get_ptr(py_obj);
	struct ndr_pull *pull = NULL;
	enum ndr_err_code err;

	if (ndr_table_frsblobs.num_calls < 1) {
		PyErr_SetString(PyExc_TypeError, "Internal Error, ndr_interface_call missing for py_decode_nt_backup_file_ndr_unpack");
		return NULL;
	}
	call = &ndr_table_frsblobs.calls[0];

	pull = ndr_pull_init_blob(blob, object);
	if (pull == NULL) {
		PyErr_SetNdrError(NDR_ERR_ALLOC);
		return NULL;
	}

	pull->flags |= ndr_pull_flags;

	err = call->ndr_pull(pull, ndr_inout_flags, object);
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		TALLOC_FREE(pull);
		PyErr_SetNdrError(err);
		return NULL;
	}
	if (!allow_remaining) {
		uint32_t highest_ofs;

		if (pull->offset > pull->relative_highest_offset) {
			highest_ofs = pull->offset;
		} else {
			highest_ofs = pull->relative_highest_offset;
		}
		if (highest_ofs < pull->data_size) {
			err = ndr_pull_error(pull, NDR_ERR_UNREAD_BYTES,
				"not all bytes consumed ofs[%u] size[%u]",
				highest_ofs, pull->data_size);
			TALLOC_FREE(pull);
			PyErr_SetNdrError(err);
			return NULL;
		}
	}

	TALLOC_FREE(pull);
	Py_RETURN_NONE;
}

static PyObject *py_decode_nt_backup_file_ndr_unpack_in(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	DATA_BLOB blob;
	Py_ssize_t blob_length = 0;
	const char * const kwnames[] = { "data_blob", "bigendian", "ndr64", "allow_remaining", NULL };
	PyObject *bigendian_obj = NULL;
	PyObject *ndr64_obj = NULL;
	uint32_t ndr_pull_flags = LIBNDR_FLAG_REF_ALLOC;
	PyObject *allow_remaining_obj = NULL;
	bool allow_remaining = false;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, PYARG_BYTES_LEN "|OOO:__ndr_unpack_in__",
		discard_const_p(char *, kwnames),
		&blob.data, &blob_length,
		&bigendian_obj,
		&ndr64_obj,
		&allow_remaining_obj)) {
		return NULL;
	}
	blob.length = blob_length;

	if (bigendian_obj && PyObject_IsTrue(bigendian_obj)) {
		ndr_pull_flags |= LIBNDR_FLAG_BIGENDIAN;
	}
	if (ndr64_obj && PyObject_IsTrue(ndr64_obj)) {
		ndr_pull_flags |= LIBNDR_FLAG_NDR64;
	}

	if (allow_remaining_obj && PyObject_IsTrue(allow_remaining_obj)) {
		allow_remaining = true;
	}

	return py_decode_nt_backup_file_ndr_unpack(py_obj, &blob, NDR_IN, ndr_pull_flags, allow_remaining);
}

static PyObject *py_decode_nt_backup_file_ndr_unpack_out(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	DATA_BLOB blob;
	Py_ssize_t blob_length = 0;
	const char * const kwnames[] = { "data_blob", "bigendian", "ndr64", "allow_remaining", NULL };
	PyObject *bigendian_obj = NULL;
	PyObject *ndr64_obj = NULL;
	uint32_t ndr_pull_flags = LIBNDR_FLAG_REF_ALLOC;
	PyObject *allow_remaining_obj = NULL;
	bool allow_remaining = false;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, PYARG_BYTES_LEN "|OOO:__ndr_unpack_out__",
		discard_const_p(char *, kwnames),
		&blob.data, &blob_length,
		&bigendian_obj,
		&ndr64_obj,
		&allow_remaining_obj)) {
		return NULL;
	}
	blob.length = blob_length;

	if (bigendian_obj && PyObject_IsTrue(bigendian_obj)) {
		ndr_pull_flags |= LIBNDR_FLAG_BIGENDIAN;
	}
	if (ndr64_obj && PyObject_IsTrue(ndr64_obj)) {
		ndr_pull_flags |= LIBNDR_FLAG_NDR64;
	}

	if (allow_remaining_obj && PyObject_IsTrue(allow_remaining_obj)) {
		allow_remaining = true;
	}

	return py_decode_nt_backup_file_ndr_unpack(py_obj, &blob, NDR_OUT, ndr_pull_flags, allow_remaining);
}

static PyObject *py_decode_nt_backup_file_ndr_print(PyObject *py_obj, const char *name, int ndr_inout_flags)
{
	const struct ndr_interface_call *call = NULL;
	struct decode_nt_backup_file *object = (struct decode_nt_backup_file *)pytalloc_get_ptr(py_obj);
	PyObject *ret;
	char *retstr;

	if (ndr_table_frsblobs.num_calls < 1) {
		PyErr_SetString(PyExc_TypeError, "Internal Error, ndr_interface_call missing for py_decode_nt_backup_file_ndr_print");
		return NULL;
	}
	call = &ndr_table_frsblobs.calls[0];

	retstr = ndr_print_function_string(pytalloc_get_mem_ctx(py_obj), call->ndr_print, name, ndr_inout_flags, object);
	ret = PyStr_FromString(retstr);
	TALLOC_FREE(retstr);

	return ret;
}

static PyObject *py_decode_nt_backup_file_ndr_print_in(PyObject *py_obj, PyObject *py_obj2)
{
	return py_decode_nt_backup_file_ndr_print(py_obj, "decode_nt_backup_file_in", NDR_IN);
}

static PyObject *py_decode_nt_backup_file_ndr_print_out(PyObject *py_obj, PyObject *py_obj2)
{
	return py_decode_nt_backup_file_ndr_print(py_obj, "decode_nt_backup_file_out", NDR_OUT);
}

static PyMethodDef py_decode_nt_backup_file_methods[] = {
	{ "opnum", (PyCFunction)py_decode_nt_backup_file_ndr_opnum, METH_NOARGS|METH_CLASS,
		"frsblobs.decode_nt_backup_file.opnum() -> 0 (0x00) " },
	{ "__ndr_pack_in__", (PyCFunction)py_decode_nt_backup_file_ndr_pack_in, METH_VARARGS|METH_KEYWORDS,
		"S.ndr_pack_in(object, bigendian=False, ndr64=False) -> blob\nNDR pack input" },
	{ "__ndr_pack_out__", (PyCFunction)py_decode_nt_backup_file_ndr_pack_out, METH_VARARGS|METH_KEYWORDS,
		"S.ndr_pack_out(object, bigendian=False, ndr64=False) -> blob\nNDR pack output" },
	{ "__ndr_unpack_in__", (PyCFunction)py_decode_nt_backup_file_ndr_unpack_in, METH_VARARGS|METH_KEYWORDS,
		"S.ndr_unpack_in(class, blob, bigendian=False, ndr64=False, allow_remaining=False) -> None\nNDR unpack input" },
	{ "__ndr_unpack_out__", (PyCFunction)py_decode_nt_backup_file_ndr_unpack_out, METH_VARARGS|METH_KEYWORDS,
		"S.ndr_unpack_out(class, blob, bigendian=False, ndr64=False, allow_remaining=False) -> None\nNDR unpack output" },
	{ "__ndr_print_in__", (PyCFunction)py_decode_nt_backup_file_ndr_print_in, METH_NOARGS, "S.ndr_print_in(object) -> None\nNDR print input" },
	{ "__ndr_print_out__", (PyCFunction)py_decode_nt_backup_file_ndr_print_out, METH_NOARGS, "S.ndr_print_out(object) -> None\nNDR print output" },
	{ NULL, NULL, 0, NULL }
};


static PyTypeObject decode_nt_backup_file_Type = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "frsblobs.decode_nt_backup_file",
	.tp_getset = py_decode_nt_backup_file_getsetters,
	.tp_methods = py_decode_nt_backup_file_methods,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = py_decode_nt_backup_file_new,
};

static bool pack_py_decode_nt_backup_file_args_in(PyObject *args, PyObject *kwargs, struct decode_nt_backup_file *r)
{
	PyObject *py_file;
	const char *kwnames[] = {
		"file", NULL
	};

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:decode_nt_backup_file", discard_const_p(char *, kwnames), &py_file)) {
		return false;
	}

	if (py_file == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct r->in.file");
		return false;
	}
	PY_CHECK_TYPE(bkup_NTBackupFile_Type, py_file, return false;);
	if (talloc_reference(r, pytalloc_get_mem_ctx(py_file)) == NULL) {
		PyErr_NoMemory();
		return false;
	}
	r->in.file = *(struct bkup_NTBackupFile *)pytalloc_get_ptr(py_file);
	return true;
}

static PyObject *unpack_py_decode_nt_backup_file_args_out(struct decode_nt_backup_file *r)
{
	PyObject *result;
	result = Py_None;
	Py_INCREF(result);
	return result;
}


static PyObject *py_decode_frsrpc_StageHeader_in_get_header(PyObject *obj, void *closure)
{
	struct decode_frsrpc_StageHeader *object = (struct decode_frsrpc_StageHeader *)pytalloc_get_ptr(obj);
	PyObject *py_header;
	py_header = pytalloc_reference_ex(frsrpc_StageHeader_Type, pytalloc_get_mem_ctx(obj), &object->in.header);
	return py_header;
}

static int py_decode_frsrpc_StageHeader_in_set_header(PyObject *py_obj, PyObject *value, void *closure)
{
	struct decode_frsrpc_StageHeader *object = (struct decode_frsrpc_StageHeader *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->in.header");
		return -1;
	}
	PY_CHECK_TYPE(frsrpc_StageHeader_Type, value, return -1;);
	if (talloc_reference(pytalloc_get_mem_ctx(py_obj), pytalloc_get_mem_ctx(value)) == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	object->in.header = *(struct frsrpc_StageHeader *)pytalloc_get_ptr(value);
	return 0;
}

static PyObject *py_decode_frsrpc_StageHeader_in_get_data(PyObject *obj, void *closure)
{
	struct decode_frsrpc_StageHeader *object = (struct decode_frsrpc_StageHeader *)pytalloc_get_ptr(obj);
	PyObject *py_data;
	py_data = pytalloc_reference_ex(bkup_NTBackupFile_Type, pytalloc_get_mem_ctx(obj), &object->in.data);
	return py_data;
}

static int py_decode_frsrpc_StageHeader_in_set_data(PyObject *py_obj, PyObject *value, void *closure)
{
	struct decode_frsrpc_StageHeader *object = (struct decode_frsrpc_StageHeader *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->in.data");
		return -1;
	}
	PY_CHECK_TYPE(bkup_NTBackupFile_Type, value, return -1;);
	if (talloc_reference(pytalloc_get_mem_ctx(py_obj), pytalloc_get_mem_ctx(value)) == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	object->in.data = *(struct bkup_NTBackupFile *)pytalloc_get_ptr(value);
	return 0;
}

static PyGetSetDef py_decode_frsrpc_StageHeader_getsetters[] = {
	{
		.name = discard_const_p(char, "in_header"),
		.get = py_decode_frsrpc_StageHeader_in_get_header,
		.set = py_decode_frsrpc_StageHeader_in_set_header,
		.doc = discard_const_p(char, "PIDL-generated element of base type frsrpc_StageHeader")
	},
	{
		.name = discard_const_p(char, "in_data"),
		.get = py_decode_frsrpc_StageHeader_in_get_data,
		.set = py_decode_frsrpc_StageHeader_in_set_data,
		.doc = discard_const_p(char, "PIDL-generated element of base type bkup_NTBackupFile")
	},
	{ .name = NULL }
};

static PyObject *py_decode_frsrpc_StageHeader_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return pytalloc_new(struct decode_frsrpc_StageHeader, type);
}

static PyObject *py_decode_frsrpc_StageHeader_ndr_opnum(PyTypeObject *type)
{


	return PyInt_FromLong(1);
}

static PyObject *py_decode_frsrpc_StageHeader_ndr_pack(PyObject *py_obj, int ndr_inout_flags, uint32_t ndr_push_flags)
{
	const struct ndr_interface_call *call = NULL;
	struct decode_frsrpc_StageHeader *object = (struct decode_frsrpc_StageHeader *)pytalloc_get_ptr(py_obj);
	PyObject *ret = NULL;
	struct ndr_push *push = NULL;
	DATA_BLOB blob;
	enum ndr_err_code err;

	if (ndr_table_frsblobs.num_calls < 2) {
		PyErr_SetString(PyExc_TypeError, "Internal Error, ndr_interface_call missing for py_decode_frsrpc_StageHeader_ndr_pack");
		return NULL;
	}
	call = &ndr_table_frsblobs.calls[1];

	push = ndr_push_init_ctx(pytalloc_get_mem_ctx(py_obj));
	if (push == NULL) {
		PyErr_SetNdrError(NDR_ERR_ALLOC);
		return NULL;
	}

	push->flags |= ndr_push_flags;

	err = call->ndr_push(push, ndr_inout_flags, object);
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		TALLOC_FREE(push);
		PyErr_SetNdrError(err);
		return NULL;
	}
	blob = ndr_push_blob(push);
	ret = PyBytes_FromStringAndSize((char *)blob.data, blob.length);
	TALLOC_FREE(push);
	return ret;
}

static PyObject *py_decode_frsrpc_StageHeader_ndr_pack_in(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	const char * const kwnames[] = { "bigendian", "ndr64", NULL };
	PyObject *bigendian_obj = NULL;
	PyObject *ndr64_obj = NULL;
	uint32_t ndr_push_flags = 0;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, "|OO:__ndr_pack_in__",
		discard_const_p(char *, kwnames),
		&bigendian_obj,
		&ndr64_obj)) {
		return NULL;
	}

	if (bigendian_obj && PyObject_IsTrue(bigendian_obj)) {
		ndr_push_flags |= LIBNDR_FLAG_BIGENDIAN;
	}
	if (ndr64_obj && PyObject_IsTrue(ndr64_obj)) {
		ndr_push_flags |= LIBNDR_FLAG_NDR64;
	}

	return py_decode_frsrpc_StageHeader_ndr_pack(py_obj, NDR_IN, ndr_push_flags);
}

static PyObject *py_decode_frsrpc_StageHeader_ndr_pack_out(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	const char * const kwnames[] = { "bigendian", "ndr64", NULL };
	PyObject *bigendian_obj = NULL;
	PyObject *ndr64_obj = NULL;
	uint32_t ndr_push_flags = 0;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, "|OO:__ndr_pack_out__",
		discard_const_p(char *, kwnames),
		&bigendian_obj,
		&ndr64_obj)) {
		return NULL;
	}

	if (bigendian_obj && PyObject_IsTrue(bigendian_obj)) {
		ndr_push_flags |= LIBNDR_FLAG_BIGENDIAN;
	}
	if (ndr64_obj && PyObject_IsTrue(ndr64_obj)) {
		ndr_push_flags |= LIBNDR_FLAG_NDR64;
	}

	return py_decode_frsrpc_StageHeader_ndr_pack(py_obj, NDR_OUT, ndr_push_flags);
}

static PyObject *py_decode_frsrpc_StageHeader_ndr_unpack(PyObject *py_obj, const DATA_BLOB *blob, int ndr_inout_flags, uint32_t ndr_pull_flags, bool allow_remaining)
{
	const struct ndr_interface_call *call = NULL;
	struct decode_frsrpc_StageHeader *object = (struct decode_frsrpc_StageHeader *)pytalloc_get_ptr(py_obj);
	struct ndr_pull *pull = NULL;
	enum ndr_err_code err;

	if (ndr_table_frsblobs.num_calls < 2) {
		PyErr_SetString(PyExc_TypeError, "Internal Error, ndr_interface_call missing for py_decode_frsrpc_StageHeader_ndr_unpack");
		return NULL;
	}
	call = &ndr_table_frsblobs.calls[1];

	pull = ndr_pull_init_blob(blob, object);
	if (pull == NULL) {
		PyErr_SetNdrError(NDR_ERR_ALLOC);
		return NULL;
	}

	pull->flags |= ndr_pull_flags;

	err = call->ndr_pull(pull, ndr_inout_flags, object);
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		TALLOC_FREE(pull);
		PyErr_SetNdrError(err);
		return NULL;
	}
	if (!allow_remaining) {
		uint32_t highest_ofs;

		if (pull->offset > pull->relative_highest_offset) {
			highest_ofs = pull->offset;
		} else {
			highest_ofs = pull->relative_highest_offset;
		}
		if (highest_ofs < pull->data_size) {
			err = ndr_pull_error(pull, NDR_ERR_UNREAD_BYTES,
				"not all bytes consumed ofs[%u] size[%u]",
				highest_ofs, pull->data_size);
			TALLOC_FREE(pull);
			PyErr_SetNdrError(err);
			return NULL;
		}
	}

	TALLOC_FREE(pull);
	Py_RETURN_NONE;
}

static PyObject *py_decode_frsrpc_StageHeader_ndr_unpack_in(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	DATA_BLOB blob;
	Py_ssize_t blob_length = 0;
	const char * const kwnames[] = { "data_blob", "bigendian", "ndr64", "allow_remaining", NULL };
	PyObject *bigendian_obj = NULL;
	PyObject *ndr64_obj = NULL;
	uint32_t ndr_pull_flags = LIBNDR_FLAG_REF_ALLOC;
	PyObject *allow_remaining_obj = NULL;
	bool allow_remaining = false;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, PYARG_BYTES_LEN "|OOO:__ndr_unpack_in__",
		discard_const_p(char *, kwnames),
		&blob.data, &blob_length,
		&bigendian_obj,
		&ndr64_obj,
		&allow_remaining_obj)) {
		return NULL;
	}
	blob.length = blob_length;

	if (bigendian_obj && PyObject_IsTrue(bigendian_obj)) {
		ndr_pull_flags |= LIBNDR_FLAG_BIGENDIAN;
	}
	if (ndr64_obj && PyObject_IsTrue(ndr64_obj)) {
		ndr_pull_flags |= LIBNDR_FLAG_NDR64;
	}

	if (allow_remaining_obj && PyObject_IsTrue(allow_remaining_obj)) {
		allow_remaining = true;
	}

	return py_decode_frsrpc_StageHeader_ndr_unpack(py_obj, &blob, NDR_IN, ndr_pull_flags, allow_remaining);
}

static PyObject *py_decode_frsrpc_StageHeader_ndr_unpack_out(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	DATA_BLOB blob;
	Py_ssize_t blob_length = 0;
	const char * const kwnames[] = { "data_blob", "bigendian", "ndr64", "allow_remaining", NULL };
	PyObject *bigendian_obj = NULL;
	PyObject *ndr64_obj = NULL;
	uint32_t ndr_pull_flags = LIBNDR_FLAG_REF_ALLOC;
	PyObject *allow_remaining_obj = NULL;
	bool allow_remaining = false;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, PYARG_BYTES_LEN "|OOO:__ndr_unpack_out__",
		discard_const_p(char *, kwnames),
		&blob.data, &blob_length,
		&bigendian_obj,
		&ndr64_obj,
		&allow_remaining_obj)) {
		return NULL;
	}
	blob.length = blob_length;

	if (bigendian_obj && PyObject_IsTrue(bigendian_obj)) {
		ndr_pull_flags |= LIBNDR_FLAG_BIGENDIAN;
	}
	if (ndr64_obj && PyObject_IsTrue(ndr64_obj)) {
		ndr_pull_flags |= LIBNDR_FLAG_NDR64;
	}

	if (allow_remaining_obj && PyObject_IsTrue(allow_remaining_obj)) {
		allow_remaining = true;
	}

	return py_decode_frsrpc_StageHeader_ndr_unpack(py_obj, &blob, NDR_OUT, ndr_pull_flags, allow_remaining);
}

static PyObject *py_decode_frsrpc_StageHeader_ndr_print(PyObject *py_obj, const char *name, int ndr_inout_flags)
{
	const struct ndr_interface_call *call = NULL;
	struct decode_frsrpc_StageHeader *object = (struct decode_frsrpc_StageHeader *)pytalloc_get_ptr(py_obj);
	PyObject *ret;
	char *retstr;

	if (ndr_table_frsblobs.num_calls < 2) {
		PyErr_SetString(PyExc_TypeError, "Internal Error, ndr_interface_call missing for py_decode_frsrpc_StageHeader_ndr_print");
		return NULL;
	}
	call = &ndr_table_frsblobs.calls[1];

	retstr = ndr_print_function_string(pytalloc_get_mem_ctx(py_obj), call->ndr_print, name, ndr_inout_flags, object);
	ret = PyStr_FromString(retstr);
	TALLOC_FREE(retstr);

	return ret;
}

static PyObject *py_decode_frsrpc_StageHeader_ndr_print_in(PyObject *py_obj, PyObject *py_obj2)
{
	return py_decode_frsrpc_StageHeader_ndr_print(py_obj, "decode_frsrpc_StageHeader_in", NDR_IN);
}

static PyObject *py_decode_frsrpc_StageHeader_ndr_print_out(PyObject *py_obj, PyObject *py_obj2)
{
	return py_decode_frsrpc_StageHeader_ndr_print(py_obj, "decode_frsrpc_StageHeader_out", NDR_OUT);
}

static PyMethodDef py_decode_frsrpc_StageHeader_methods[] = {
	{ "opnum", (PyCFunction)py_decode_frsrpc_StageHeader_ndr_opnum, METH_NOARGS|METH_CLASS,
		"frsblobs.decode_frsrpc_StageHeader.opnum() -> 1 (0x01) " },
	{ "__ndr_pack_in__", (PyCFunction)py_decode_frsrpc_StageHeader_ndr_pack_in, METH_VARARGS|METH_KEYWORDS,
		"S.ndr_pack_in(object, bigendian=False, ndr64=False) -> blob\nNDR pack input" },
	{ "__ndr_pack_out__", (PyCFunction)py_decode_frsrpc_StageHeader_ndr_pack_out, METH_VARARGS|METH_KEYWORDS,
		"S.ndr_pack_out(object, bigendian=False, ndr64=False) -> blob\nNDR pack output" },
	{ "__ndr_unpack_in__", (PyCFunction)py_decode_frsrpc_StageHeader_ndr_unpack_in, METH_VARARGS|METH_KEYWORDS,
		"S.ndr_unpack_in(class, blob, bigendian=False, ndr64=False, allow_remaining=False) -> None\nNDR unpack input" },
	{ "__ndr_unpack_out__", (PyCFunction)py_decode_frsrpc_StageHeader_ndr_unpack_out, METH_VARARGS|METH_KEYWORDS,
		"S.ndr_unpack_out(class, blob, bigendian=False, ndr64=False, allow_remaining=False) -> None\nNDR unpack output" },
	{ "__ndr_print_in__", (PyCFunction)py_decode_frsrpc_StageHeader_ndr_print_in, METH_NOARGS, "S.ndr_print_in(object) -> None\nNDR print input" },
	{ "__ndr_print_out__", (PyCFunction)py_decode_frsrpc_StageHeader_ndr_print_out, METH_NOARGS, "S.ndr_print_out(object) -> None\nNDR print output" },
	{ NULL, NULL, 0, NULL }
};


static PyTypeObject decode_frsrpc_StageHeader_Type = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "frsblobs.decode_frsrpc_StageHeader",
	.tp_getset = py_decode_frsrpc_StageHeader_getsetters,
	.tp_methods = py_decode_frsrpc_StageHeader_methods,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = py_decode_frsrpc_StageHeader_new,
};

static bool pack_py_decode_frsrpc_StageHeader_args_in(PyObject *args, PyObject *kwargs, struct decode_frsrpc_StageHeader *r)
{
	PyObject *py_header;
	PyObject *py_data;
	const char *kwnames[] = {
		"header", "data", NULL
	};

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, "OO:decode_frsrpc_StageHeader", discard_const_p(char *, kwnames), &py_header, &py_data)) {
		return false;
	}

	if (py_header == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct r->in.header");
		return false;
	}
	PY_CHECK_TYPE(frsrpc_StageHeader_Type, py_header, return false;);
	if (talloc_reference(r, pytalloc_get_mem_ctx(py_header)) == NULL) {
		PyErr_NoMemory();
		return false;
	}
	r->in.header = *(struct frsrpc_StageHeader *)pytalloc_get_ptr(py_header);
	if (py_data == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct r->in.data");
		return false;
	}
	PY_CHECK_TYPE(bkup_NTBackupFile_Type, py_data, return false;);
	if (talloc_reference(r, pytalloc_get_mem_ctx(py_data)) == NULL) {
		PyErr_NoMemory();
		return false;
	}
	r->in.data = *(struct bkup_NTBackupFile *)pytalloc_get_ptr(py_data);
	return true;
}

static PyObject *unpack_py_decode_frsrpc_StageHeader_args_out(struct decode_frsrpc_StageHeader *r)
{
	PyObject *result;
	result = Py_None;
	Py_INCREF(result);
	return result;
}


static PyObject *py_decode_FileNetworkOpenInformation_in_get_data(PyObject *obj, void *closure)
{
	struct decode_FileNetworkOpenInformation *object = (struct decode_FileNetworkOpenInformation *)pytalloc_get_ptr(obj);
	PyObject *py_data;
	py_data = pytalloc_reference_ex(fscc_FileNetworkOpenInformation_Type, pytalloc_get_mem_ctx(obj), &object->in.data);
	return py_data;
}

static int py_decode_FileNetworkOpenInformation_in_set_data(PyObject *py_obj, PyObject *value, void *closure)
{
	struct decode_FileNetworkOpenInformation *object = (struct decode_FileNetworkOpenInformation *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->in.data");
		return -1;
	}
	PY_CHECK_TYPE(fscc_FileNetworkOpenInformation_Type, value, return -1;);
	if (talloc_reference(pytalloc_get_mem_ctx(py_obj), pytalloc_get_mem_ctx(value)) == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	object->in.data = *(struct fscc_FileNetworkOpenInformation *)pytalloc_get_ptr(value);
	return 0;
}

static PyGetSetDef py_decode_FileNetworkOpenInformation_getsetters[] = {
	{
		.name = discard_const_p(char, "in_data"),
		.get = py_decode_FileNetworkOpenInformation_in_get_data,
		.set = py_decode_FileNetworkOpenInformation_in_set_data,
		.doc = discard_const_p(char, "PIDL-generated element of base type fscc_FileNetworkOpenInformation")
	},
	{ .name = NULL }
};

static PyObject *py_decode_FileNetworkOpenInformation_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return pytalloc_new(struct decode_FileNetworkOpenInformation, type);
}

static PyObject *py_decode_FileNetworkOpenInformation_ndr_opnum(PyTypeObject *type)
{


	return PyInt_FromLong(2);
}

static PyObject *py_decode_FileNetworkOpenInformation_ndr_pack(PyObject *py_obj, int ndr_inout_flags, uint32_t ndr_push_flags)
{
	const struct ndr_interface_call *call = NULL;
	struct decode_FileNetworkOpenInformation *object = (struct decode_FileNetworkOpenInformation *)pytalloc_get_ptr(py_obj);
	PyObject *ret = NULL;
	struct ndr_push *push = NULL;
	DATA_BLOB blob;
	enum ndr_err_code err;

	if (ndr_table_frsblobs.num_calls < 3) {
		PyErr_SetString(PyExc_TypeError, "Internal Error, ndr_interface_call missing for py_decode_FileNetworkOpenInformation_ndr_pack");
		return NULL;
	}
	call = &ndr_table_frsblobs.calls[2];

	push = ndr_push_init_ctx(pytalloc_get_mem_ctx(py_obj));
	if (push == NULL) {
		PyErr_SetNdrError(NDR_ERR_ALLOC);
		return NULL;
	}

	push->flags |= ndr_push_flags;

	err = call->ndr_push(push, ndr_inout_flags, object);
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		TALLOC_FREE(push);
		PyErr_SetNdrError(err);
		return NULL;
	}
	blob = ndr_push_blob(push);
	ret = PyBytes_FromStringAndSize((char *)blob.data, blob.length);
	TALLOC_FREE(push);
	return ret;
}

static PyObject *py_decode_FileNetworkOpenInformation_ndr_pack_in(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	const char * const kwnames[] = { "bigendian", "ndr64", NULL };
	PyObject *bigendian_obj = NULL;
	PyObject *ndr64_obj = NULL;
	uint32_t ndr_push_flags = 0;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, "|OO:__ndr_pack_in__",
		discard_const_p(char *, kwnames),
		&bigendian_obj,
		&ndr64_obj)) {
		return NULL;
	}

	if (bigendian_obj && PyObject_IsTrue(bigendian_obj)) {
		ndr_push_flags |= LIBNDR_FLAG_BIGENDIAN;
	}
	if (ndr64_obj && PyObject_IsTrue(ndr64_obj)) {
		ndr_push_flags |= LIBNDR_FLAG_NDR64;
	}

	return py_decode_FileNetworkOpenInformation_ndr_pack(py_obj, NDR_IN, ndr_push_flags);
}

static PyObject *py_decode_FileNetworkOpenInformation_ndr_pack_out(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	const char * const kwnames[] = { "bigendian", "ndr64", NULL };
	PyObject *bigendian_obj = NULL;
	PyObject *ndr64_obj = NULL;
	uint32_t ndr_push_flags = 0;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, "|OO:__ndr_pack_out__",
		discard_const_p(char *, kwnames),
		&bigendian_obj,
		&ndr64_obj)) {
		return NULL;
	}

	if (bigendian_obj && PyObject_IsTrue(bigendian_obj)) {
		ndr_push_flags |= LIBNDR_FLAG_BIGENDIAN;
	}
	if (ndr64_obj && PyObject_IsTrue(ndr64_obj)) {
		ndr_push_flags |= LIBNDR_FLAG_NDR64;
	}

	return py_decode_FileNetworkOpenInformation_ndr_pack(py_obj, NDR_OUT, ndr_push_flags);
}

static PyObject *py_decode_FileNetworkOpenInformation_ndr_unpack(PyObject *py_obj, const DATA_BLOB *blob, int ndr_inout_flags, uint32_t ndr_pull_flags, bool allow_remaining)
{
	const struct ndr_interface_call *call = NULL;
	struct decode_FileNetworkOpenInformation *object = (struct decode_FileNetworkOpenInformation *)pytalloc_get_ptr(py_obj);
	struct ndr_pull *pull = NULL;
	enum ndr_err_code err;

	if (ndr_table_frsblobs.num_calls < 3) {
		PyErr_SetString(PyExc_TypeError, "Internal Error, ndr_interface_call missing for py_decode_FileNetworkOpenInformation_ndr_unpack");
		return NULL;
	}
	call = &ndr_table_frsblobs.calls[2];

	pull = ndr_pull_init_blob(blob, object);
	if (pull == NULL) {
		PyErr_SetNdrError(NDR_ERR_ALLOC);
		return NULL;
	}

	pull->flags |= ndr_pull_flags;

	err = call->ndr_pull(pull, ndr_inout_flags, object);
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		TALLOC_FREE(pull);
		PyErr_SetNdrError(err);
		return NULL;
	}
	if (!allow_remaining) {
		uint32_t highest_ofs;

		if (pull->offset > pull->relative_highest_offset) {
			highest_ofs = pull->offset;
		} else {
			highest_ofs = pull->relative_highest_offset;
		}
		if (highest_ofs < pull->data_size) {
			err = ndr_pull_error(pull, NDR_ERR_UNREAD_BYTES,
				"not all bytes consumed ofs[%u] size[%u]",
				highest_ofs, pull->data_size);
			TALLOC_FREE(pull);
			PyErr_SetNdrError(err);
			return NULL;
		}
	}

	TALLOC_FREE(pull);
	Py_RETURN_NONE;
}

static PyObject *py_decode_FileNetworkOpenInformation_ndr_unpack_in(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	DATA_BLOB blob;
	Py_ssize_t blob_length = 0;
	const char * const kwnames[] = { "data_blob", "bigendian", "ndr64", "allow_remaining", NULL };
	PyObject *bigendian_obj = NULL;
	PyObject *ndr64_obj = NULL;
	uint32_t ndr_pull_flags = LIBNDR_FLAG_REF_ALLOC;
	PyObject *allow_remaining_obj = NULL;
	bool allow_remaining = false;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, PYARG_BYTES_LEN "|OOO:__ndr_unpack_in__",
		discard_const_p(char *, kwnames),
		&blob.data, &blob_length,
		&bigendian_obj,
		&ndr64_obj,
		&allow_remaining_obj)) {
		return NULL;
	}
	blob.length = blob_length;

	if (bigendian_obj && PyObject_IsTrue(bigendian_obj)) {
		ndr_pull_flags |= LIBNDR_FLAG_BIGENDIAN;
	}
	if (ndr64_obj && PyObject_IsTrue(ndr64_obj)) {
		ndr_pull_flags |= LIBNDR_FLAG_NDR64;
	}

	if (allow_remaining_obj && PyObject_IsTrue(allow_remaining_obj)) {
		allow_remaining = true;
	}

	return py_decode_FileNetworkOpenInformation_ndr_unpack(py_obj, &blob, NDR_IN, ndr_pull_flags, allow_remaining);
}

static PyObject *py_decode_FileNetworkOpenInformation_ndr_unpack_out(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	DATA_BLOB blob;
	Py_ssize_t blob_length = 0;
	const char * const kwnames[] = { "data_blob", "bigendian", "ndr64", "allow_remaining", NULL };
	PyObject *bigendian_obj = NULL;
	PyObject *ndr64_obj = NULL;
	uint32_t ndr_pull_flags = LIBNDR_FLAG_REF_ALLOC;
	PyObject *allow_remaining_obj = NULL;
	bool allow_remaining = false;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, PYARG_BYTES_LEN "|OOO:__ndr_unpack_out__",
		discard_const_p(char *, kwnames),
		&blob.data, &blob_length,
		&bigendian_obj,
		&ndr64_obj,
		&allow_remaining_obj)) {
		return NULL;
	}
	blob.length = blob_length;

	if (bigendian_obj && PyObject_IsTrue(bigendian_obj)) {
		ndr_pull_flags |= LIBNDR_FLAG_BIGENDIAN;
	}
	if (ndr64_obj && PyObject_IsTrue(ndr64_obj)) {
		ndr_pull_flags |= LIBNDR_FLAG_NDR64;
	}

	if (allow_remaining_obj && PyObject_IsTrue(allow_remaining_obj)) {
		allow_remaining = true;
	}

	return py_decode_FileNetworkOpenInformation_ndr_unpack(py_obj, &blob, NDR_OUT, ndr_pull_flags, allow_remaining);
}

static PyObject *py_decode_FileNetworkOpenInformation_ndr_print(PyObject *py_obj, const char *name, int ndr_inout_flags)
{
	const struct ndr_interface_call *call = NULL;
	struct decode_FileNetworkOpenInformation *object = (struct decode_FileNetworkOpenInformation *)pytalloc_get_ptr(py_obj);
	PyObject *ret;
	char *retstr;

	if (ndr_table_frsblobs.num_calls < 3) {
		PyErr_SetString(PyExc_TypeError, "Internal Error, ndr_interface_call missing for py_decode_FileNetworkOpenInformation_ndr_print");
		return NULL;
	}
	call = &ndr_table_frsblobs.calls[2];

	retstr = ndr_print_function_string(pytalloc_get_mem_ctx(py_obj), call->ndr_print, name, ndr_inout_flags, object);
	ret = PyStr_FromString(retstr);
	TALLOC_FREE(retstr);

	return ret;
}

static PyObject *py_decode_FileNetworkOpenInformation_ndr_print_in(PyObject *py_obj, PyObject *py_obj2)
{
	return py_decode_FileNetworkOpenInformation_ndr_print(py_obj, "decode_FileNetworkOpenInformation_in", NDR_IN);
}

static PyObject *py_decode_FileNetworkOpenInformation_ndr_print_out(PyObject *py_obj, PyObject *py_obj2)
{
	return py_decode_FileNetworkOpenInformation_ndr_print(py_obj, "decode_FileNetworkOpenInformation_out", NDR_OUT);
}

static PyMethodDef py_decode_FileNetworkOpenInformation_methods[] = {
	{ "opnum", (PyCFunction)py_decode_FileNetworkOpenInformation_ndr_opnum, METH_NOARGS|METH_CLASS,
		"frsblobs.decode_FileNetworkOpenInformation.opnum() -> 2 (0x02) " },
	{ "__ndr_pack_in__", (PyCFunction)py_decode_FileNetworkOpenInformation_ndr_pack_in, METH_VARARGS|METH_KEYWORDS,
		"S.ndr_pack_in(object, bigendian=False, ndr64=False) -> blob\nNDR pack input" },
	{ "__ndr_pack_out__", (PyCFunction)py_decode_FileNetworkOpenInformation_ndr_pack_out, METH_VARARGS|METH_KEYWORDS,
		"S.ndr_pack_out(object, bigendian=False, ndr64=False) -> blob\nNDR pack output" },
	{ "__ndr_unpack_in__", (PyCFunction)py_decode_FileNetworkOpenInformation_ndr_unpack_in, METH_VARARGS|METH_KEYWORDS,
		"S.ndr_unpack_in(class, blob, bigendian=False, ndr64=False, allow_remaining=False) -> None\nNDR unpack input" },
	{ "__ndr_unpack_out__", (PyCFunction)py_decode_FileNetworkOpenInformation_ndr_unpack_out, METH_VARARGS|METH_KEYWORDS,
		"S.ndr_unpack_out(class, blob, bigendian=False, ndr64=False, allow_remaining=False) -> None\nNDR unpack output" },
	{ "__ndr_print_in__", (PyCFunction)py_decode_FileNetworkOpenInformation_ndr_print_in, METH_NOARGS, "S.ndr_print_in(object) -> None\nNDR print input" },
	{ "__ndr_print_out__", (PyCFunction)py_decode_FileNetworkOpenInformation_ndr_print_out, METH_NOARGS, "S.ndr_print_out(object) -> None\nNDR print output" },
	{ NULL, NULL, 0, NULL }
};


static PyTypeObject decode_FileNetworkOpenInformation_Type = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "frsblobs.decode_FileNetworkOpenInformation",
	.tp_getset = py_decode_FileNetworkOpenInformation_getsetters,
	.tp_methods = py_decode_FileNetworkOpenInformation_methods,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = py_decode_FileNetworkOpenInformation_new,
};

static bool pack_py_decode_FileNetworkOpenInformation_args_in(PyObject *args, PyObject *kwargs, struct decode_FileNetworkOpenInformation *r)
{
	PyObject *py_data;
	const char *kwnames[] = {
		"data", NULL
	};

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:decode_FileNetworkOpenInformation", discard_const_p(char *, kwnames), &py_data)) {
		return false;
	}

	if (py_data == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct r->in.data");
		return false;
	}
	PY_CHECK_TYPE(fscc_FileNetworkOpenInformation_Type, py_data, return false;);
	if (talloc_reference(r, pytalloc_get_mem_ctx(py_data)) == NULL) {
		PyErr_NoMemory();
		return false;
	}
	r->in.data = *(struct fscc_FileNetworkOpenInformation *)pytalloc_get_ptr(py_data);
	return true;
}

static PyObject *unpack_py_decode_FileNetworkOpenInformation_args_out(struct decode_FileNetworkOpenInformation *r)
{
	PyObject *result;
	result = Py_None;
	Py_INCREF(result);
	return result;
}

const struct PyNdrRpcMethodDef py_ndr_frsblobs_methods[] = {
	{ "decode_nt_backup_file", "S.decode_nt_backup_file(file) -> None", (py_dcerpc_call_fn)dcerpc_decode_nt_backup_file_r, (py_data_pack_fn)pack_py_decode_nt_backup_file_args_in, (py_data_unpack_fn)unpack_py_decode_nt_backup_file_args_out, 0, &ndr_table_frsblobs },
	{ "decode_frsrpc_StageHeader", "S.decode_frsrpc_StageHeader(header, data) -> None", (py_dcerpc_call_fn)dcerpc_decode_frsrpc_StageHeader_r, (py_data_pack_fn)pack_py_decode_frsrpc_StageHeader_args_in, (py_data_unpack_fn)unpack_py_decode_frsrpc_StageHeader_args_out, 1, &ndr_table_frsblobs },
	{ "decode_FileNetworkOpenInformation", "S.decode_FileNetworkOpenInformation(data) -> None", (py_dcerpc_call_fn)dcerpc_decode_FileNetworkOpenInformation_r, (py_data_pack_fn)pack_py_decode_FileNetworkOpenInformation_args_in, (py_data_unpack_fn)unpack_py_decode_FileNetworkOpenInformation_args_out, 2, &ndr_table_frsblobs },
	{ NULL }
};

static PyObject *interface_frsblobs_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return py_dcerpc_interface_init_helper(type, args, kwargs, &ndr_table_frsblobs);
}

#define PY_DOC_FRSBLOBS "bkup blobs"
static PyTypeObject frsblobs_InterfaceType = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "frsblobs.frsblobs",
	.tp_basicsize = sizeof(dcerpc_InterfaceObject),
	.tp_doc = "frsblobs(binding, lp_ctx=None, credentials=None) -> connection\n"
"\n"
"binding should be a DCE/RPC binding string (for example: ncacn_ip_tcp:127.0.0.1)\n"
"lp_ctx should be a path to a smb.conf file or a param.LoadParm object\n"
"credentials should be a credentials.Credentials object.\n\n"PY_DOC_FRSBLOBS,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = interface_frsblobs_new,
};

static PyObject *syntax_frsblobs_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return py_dcerpc_syntax_init_helper(type, args, kwargs, &ndr_table_frsblobs.syntax_id);
}

#define PY_DOC_FRSBLOBS_SYNTAX "bkup blobs"
static PyTypeObject frsblobs_SyntaxType = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "frsblobs.frsblobs_abstract_syntax",
	.tp_doc = "frsblobs_abstract_syntax()\n"PY_DOC_FRSBLOBS_SYNTAX,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = syntax_frsblobs_new,
};

static PyMethodDef frsblobs_methods[] = {
	{ NULL, NULL, 0, NULL }
};

static struct PyModuleDef moduledef = {
	PyModuleDef_HEAD_INIT,
	.m_name = "frsblobs",
	.m_doc = "frsblobs DCE/RPC",
	.m_size = -1,
	.m_methods = frsblobs_methods,
};
MODULE_INIT_FUNC(frsblobs)
{
	PyObject *m;
	PyObject *dep_samba_dcerpc_misc;
	PyObject *dep_samba_dcerpc_security;
	PyObject *dep_samba_dcerpc_frsrpc;
	PyObject *dep_samba_dcerpc_bkupblobs;
	PyObject *dep_samba_dcerpc_fscc;
	PyObject *dep_talloc;
	PyObject *dep_samba_dcerpc_base;

	dep_samba_dcerpc_misc = PyImport_ImportModule("samba.dcerpc.misc");
	if (dep_samba_dcerpc_misc == NULL)
		return NULL;

	dep_samba_dcerpc_security = PyImport_ImportModule("samba.dcerpc.security");
	if (dep_samba_dcerpc_security == NULL)
		return NULL;

	dep_samba_dcerpc_frsrpc = PyImport_ImportModule("samba.dcerpc.frsrpc");
	if (dep_samba_dcerpc_frsrpc == NULL)
		return NULL;

	dep_samba_dcerpc_bkupblobs = PyImport_ImportModule("samba.dcerpc.bkupblobs");
	if (dep_samba_dcerpc_bkupblobs == NULL)
		return NULL;

	dep_samba_dcerpc_fscc = PyImport_ImportModule("samba.dcerpc.fscc");
	if (dep_samba_dcerpc_fscc == NULL)
		return NULL;

	dep_talloc = PyImport_ImportModule("talloc");
	if (dep_talloc == NULL)
		return NULL;

	dep_samba_dcerpc_base = PyImport_ImportModule("samba.dcerpc.base");
	if (dep_samba_dcerpc_base == NULL)
		return NULL;

	bkup_NTBackupFile_Type = (PyTypeObject *)PyObject_GetAttrString(dep_samba_dcerpc_bkupblobs, "bkup_NTBackupFile");
	if (bkup_NTBackupFile_Type == NULL)
		return NULL;

	BaseObject_Type = (PyTypeObject *)PyObject_GetAttrString(dep_talloc, "BaseObject");
	if (BaseObject_Type == NULL)
		return NULL;

	frsrpc_StageHeader_Type = (PyTypeObject *)PyObject_GetAttrString(dep_samba_dcerpc_frsrpc, "StageHeader");
	if (frsrpc_StageHeader_Type == NULL)
		return NULL;

	fscc_FileNetworkOpenInformation_Type = (PyTypeObject *)PyObject_GetAttrString(dep_samba_dcerpc_fscc, "FileNetworkOpenInformation");
	if (fscc_FileNetworkOpenInformation_Type == NULL)
		return NULL;

	ClientConnection_Type = (PyTypeObject *)PyObject_GetAttrString(dep_samba_dcerpc_base, "ClientConnection");
	if (ClientConnection_Type == NULL)
		return NULL;

	ndr_syntax_id_Type = (PyTypeObject *)PyObject_GetAttrString(dep_samba_dcerpc_misc, "ndr_syntax_id");
	if (ndr_syntax_id_Type == NULL)
		return NULL;

	decode_nt_backup_file_Type.tp_base = BaseObject_Type;
	decode_nt_backup_file_Type.tp_basicsize = pytalloc_BaseObject_size();

	decode_frsrpc_StageHeader_Type.tp_base = BaseObject_Type;
	decode_frsrpc_StageHeader_Type.tp_basicsize = pytalloc_BaseObject_size();

	decode_FileNetworkOpenInformation_Type.tp_base = BaseObject_Type;
	decode_FileNetworkOpenInformation_Type.tp_basicsize = pytalloc_BaseObject_size();

	frsblobs_InterfaceType.tp_base = ClientConnection_Type;

	frsblobs_SyntaxType.tp_base = ndr_syntax_id_Type;
	frsblobs_SyntaxType.tp_basicsize = pytalloc_BaseObject_size();

	if (PyType_Ready(&decode_nt_backup_file_Type) < 0)
		return NULL;
	if (PyType_Ready(&decode_frsrpc_StageHeader_Type) < 0)
		return NULL;
	if (PyType_Ready(&decode_FileNetworkOpenInformation_Type) < 0)
		return NULL;
	if (PyType_Ready(&frsblobs_InterfaceType) < 0)
		return NULL;
	if (PyType_Ready(&frsblobs_SyntaxType) < 0)
		return NULL;
	if (!PyInterface_AddNdrRpcMethods(&frsblobs_InterfaceType, py_ndr_frsblobs_methods))
		return NULL;

#ifdef PY_DECODE_NT_BACKUP_FILE_PATCH
	PY_DECODE_NT_BACKUP_FILE_PATCH(&decode_nt_backup_file_Type);
#endif
#ifdef PY_DECODE_FRSRPC_STAGEHEADER_PATCH
	PY_DECODE_FRSRPC_STAGEHEADER_PATCH(&decode_frsrpc_StageHeader_Type);
#endif
#ifdef PY_DECODE_FILENETWORKOPENINFORMATION_PATCH
	PY_DECODE_FILENETWORKOPENINFORMATION_PATCH(&decode_FileNetworkOpenInformation_Type);
#endif
#ifdef PY_FRSBLOBS_PATCH
	PY_FRSBLOBS_PATCH(&frsblobs_InterfaceType);
#endif
#ifdef PY_FRSBLOBS_ABSTRACT_SYNTAX_PATCH
	PY_FRSBLOBS_ABSTRACT_SYNTAX_PATCH(&frsblobs_SyntaxType);
#endif
#ifdef PY_ABSTRACT_SYNTAX_PATCH
	PY_ABSTRACT_SYNTAX_PATCH(&frsblobs_SyntaxType);
#endif

	m = PyModule_Create(&moduledef);
	if (m == NULL)
		return NULL;

	Py_INCREF((PyObject *)(void *)&decode_nt_backup_file_Type);
	PyModule_AddObject(m, "decode_nt_backup_file", (PyObject *)(void *)&decode_nt_backup_file_Type);
	Py_INCREF((PyObject *)(void *)&decode_frsrpc_StageHeader_Type);
	PyModule_AddObject(m, "decode_frsrpc_StageHeader", (PyObject *)(void *)&decode_frsrpc_StageHeader_Type);
	Py_INCREF((PyObject *)(void *)&decode_FileNetworkOpenInformation_Type);
	PyModule_AddObject(m, "decode_FileNetworkOpenInformation", (PyObject *)(void *)&decode_FileNetworkOpenInformation_Type);
	Py_INCREF((PyObject *)(void *)&frsblobs_InterfaceType);
	PyModule_AddObject(m, "frsblobs", (PyObject *)(void *)&frsblobs_InterfaceType);
	Py_INCREF((PyObject *)(void *)&frsblobs_SyntaxType);
	PyModule_AddObject(m, "frsblobs_abstract_syntax", (PyObject *)(void *)&frsblobs_SyntaxType);
	Py_INCREF((PyObject *)(void *)&frsblobs_SyntaxType);
	PyModule_AddObject(m, "abstract_syntax", (PyObject *)(void *)&frsblobs_SyntaxType);
#ifdef PY_MOD_FRSBLOBS_PATCH
	PY_MOD_FRSBLOBS_PATCH(m);
#endif
	return m;

}
